Type: Package
Package: sass
Version: 0.4.9
Title: Syntactically Awesome Style Sheets ('Sass')
Description: An 'SCSS' compiler, powered by the 'LibSass' library. With this,
    R developers can use variables, inheritance, and functions to generate
    dynamic style sheets. The package uses the 'Sass CSS' extension language,
    which is stable, powerful, and CSS compatible.
Authors@R: c(
    person("Joe", "Cheng", , "joe@rstudio.com", "aut"),
    person("Timothy", "Mastny", , "tim.mastny@gmail.com", "aut"),
    person("Richard", "Iannone", , "rich@rstudio.com", "aut",
       comment = c(ORCID = "0000-0003-3925-190X")),
    person("Barret", "Schloerke", , "barret@rstudio.com", "aut",
           comment = c(ORCID = "0000-0001-9986-114X")),
    person("Carson", "Sievert", , "carson@rstudio.com", c("aut", "cre"),
           comment = c(ORCID = "0000-0002-4958-2844")),
    person("Christophe", "Dervieux", , "cderv@rstudio.com", c("ctb"),
           comment = c(ORCID = "0000-0003-4474-2498")),
    person(family = "RStudio", role = c("cph", "fnd")),
    person(family = "Sass Open Source Foundation", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Greter", "Marcel", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Mifsud", "Michael", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Hampton", "Catlin", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Natalie", "Weizenbaum", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Chris", "Eppstein", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Adams", "Joseph", role = c("ctb", "cph"),
           comment = "json.cpp"),
    person("Trifunovic", "Nemanja", role = c("ctb", "cph"),
           comment = "utf8.h")
    )
License: MIT + file LICENSE
URL: https://rstudio.github.io/sass/, https://github.com/rstudio/sass
BugReports: https://github.com/rstudio/sass/issues
Encoding: UTF-8
RoxygenNote: 7.3.1
SystemRequirements: GNU make
Imports: fs (>= 1.2.4), rlang (>= 0.4.10), htmltools (>= 0.5.1), R6,
        rappdirs
Suggests: testthat, knitr, rmarkdown, withr, shiny, curl
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: yes
Packaged: 2024-03-15 21:58:01 UTC; cpsievert
Author: Joe Cheng [aut],
  Timothy Mastny [aut],
  Richard Iannone [aut] (<https://orcid.org/0000-0003-3925-190X>),
  Barret Schloerke [aut] (<https://orcid.org/0000-0001-9986-114X>),
  Carson Sievert [aut, cre] (<https://orcid.org/0000-0002-4958-2844>),
  Christophe Dervieux [ctb] (<https://orcid.org/0000-0003-4474-2498>),
  RStudio [cph, fnd],
  Sass Open Source Foundation [ctb, cph] (LibSass library),
  Greter Marcel [ctb, cph] (LibSass library),
  Mifsud Michael [ctb, cph] (LibSass library),
  Hampton Catlin [ctb, cph] (LibSass library),
  Natalie Weizenbaum [ctb, cph] (LibSass library),
  Chris Eppstein [ctb, cph] (LibSass library),
  Adams Joseph [ctb, cph] (json.cpp),
  Trifunovic Nemanja [ctb, cph] (utf8.h)
Maintainer: Carson Sievert <carson@rstudio.com>
Repository: CRAN
Date/Publication: 2024-03-15 22:30:02 UTC
Built: R 4.4.0; x86_64-apple-darwin11.4.2; 2024-04-30 14:54:40 UTC; unix

Type: Package
Package: sass
Version: 0.4.9
Title: Syntactically Awesome Style Sheets ('Sass')
Description: An 'SCSS' compiler, powered by the 'LibSass' library. With this,
    R developers can use variables, inheritance, and functions to generate
    dynamic style sheets. The package uses the 'Sass CSS' extension language,
    which is stable, powerful, and CSS compatible.
Authors@R: c(
    person("Joe", "Cheng", , "joe@rstudio.com", "aut"),
    person("Timothy", "Mastny", , "tim.mastny@gmail.com", "aut"),
    person("Richard", "Iannone", , "rich@rstudio.com", "aut",
       comment = c(ORCID = "0000-0003-3925-190X")),
    person("Barret", "Schloerke", , "barret@rstudio.com", "aut",
           comment = c(ORCID = "0000-0001-9986-114X")),
    person("Carson", "Sievert", , "carson@rstudio.com", c("aut", "cre"),
           comment = c(ORCID = "0000-0002-4958-2844")),
    person("Christophe", "Dervieux", , "cderv@rstudio.com", c("ctb"),
           comment = c(ORCID = "0000-0003-4474-2498")),
    person(family = "RStudio", role = c("cph", "fnd")),
    person(family = "Sass Open Source Foundation", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Greter", "Marcel", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Mifsud", "Michael", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Hampton", "Catlin", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Natalie", "Weizenbaum", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Chris", "Eppstein", role = c("ctb", "cph"),
           comment = "LibSass library"),
    person("Adams", "Joseph", role = c("ctb", "cph"),
           comment = "json.cpp"),
    person("Trifunovic", "Nemanja", role = c("ctb", "cph"),
           comment = "utf8.h")
    )
License: MIT + file LICENSE
URL: https://rstudio.github.io/sass/, https://github.com/rstudio/sass
BugReports: https://github.com/rstudio/sass/issues
Encoding: UTF-8
RoxygenNote: 7.3.1
SystemRequirements: GNU make
Imports: fs (>= 1.2.4), rlang (>= 0.4.10), htmltools (>= 0.5.1), R6,
        rappdirs
Suggests: testthat, knitr, rmarkdown, withr, shiny, curl
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: yes
Packaged: 2024-03-15 21:58:01 UTC; cpsievert
Author: Joe Cheng [aut],
  Timothy Mastny [aut],
  Richard Iannone [aut] (<https://orcid.org/0000-0003-3925-190X>),
  Barret Schloerke [aut] (<https://orcid.org/0000-0001-9986-114X>),
  Carson Sievert [aut, cre] (<https://orcid.org/0000-0002-4958-2844>),
  Christophe Dervieux [ctb] (<https://orcid.org/0000-0003-4474-2498>),
  RStudio [cph, fnd],
  Sass Open Source Foundation [ctb, cph] (LibSass library),
  Greter Marcel [ctb, cph] (LibSass library),
  Mifsud Michael [ctb, cph] (LibSass library),
  Hampton Catlin [ctb, cph] (LibSass library),
  Natalie Weizenbaum [ctb, cph] (LibSass library),
  Chris Eppstein [ctb, cph] (LibSass library),
  Adams Joseph [ctb, cph] (json.cpp),
  Trifunovic Nemanja [ctb, cph] (utf8.h)
Maintainer: Carson Sievert <carson@rstudio.com>
Repository: CRAN
Date/Publication: 2024-03-15 22:30:02 UTC
Built: R 4.5.2; x86_64--netbsd; 2026-02-20 09:52:42 UTC; unix

This example shows how to use the [sass](https://github.com/rstudio/sass) R package to dynamically generate a stylesheet that changes the background and font color in a shiny app. The app also allows you to dynmically resize the plot width.

This example shows how to use the [sass](https://github.com/rstudio/sass) R package to dynamically generate a stylesheet that changes the background color in a shiny app. The font color also depends on the background color, changing between black and white as necessary.

This self contained example shows how to use the [sass](https://github.com/rstudio/sass) R package to generate CSS for multiple themes and dynamically create colors based off of an original theme color.  If a Shiny button is clicked, the javascript event is captured and the theme color is updated within the browser.  A Shiny server event is triggered in addition to changing the theme within browser.

Original [article](http://www.sitepoint.com/dealing-color-schemes-sass/) and [demo](https://codepen.io/SitePoint/pen/czixa) by [Hugo Giraudel](https://codepen.io/HugoGiraudel).

library(shiny)

output_css <- "theme.css"
scss <- "
// Color themes
$themes: (
  default: #666,
  banana: #f1c40f,
  cherry: #c0392b,
  blueberry: #8e44ad,
  leaf: #27ae60,
  nightsky: #2980b9
);

// Helper theme mixin
// @param $name: name of the theme (HTML class)
// @param $color: color of the theme
@mixin theme($name, $color) {
  .#{$name} {
    .component{
      border-color: darken($color, 10%);

      h2 {
        color: $color;
      }

      li {
        background: lighten($color, 45%);
      }
    }

  }

  // matches button id: #default, #banana, #cherry, ...
  ##{$name} {
    background: $color;

    // #banana:hover
    &:hover {
      background: darken($color, 10%);
    }

    // #banana[disabled]
    &[disabled] {
      background: desaturate($color, 40%);
    }
  }
}

// Including themes
// By looping through the $themes map
@each $key, $value in $themes {
  @include theme($key, $value);
}


// Default styles
.component {
  background: #EFEFEF;
  padding: 1em;
  margin-bottom: 1em;
  border-top: .5em solid;
  ul {
    list-style: none;
    padding: 0;
    overflow: hidden;
  }
  li {
    float: left;
    width: 24%;
    height: 10em;
    margin-right: 1%;
  }
}
.controls > button {
  border: none;
  color: white;
  padding: .5em;
  border-radius: .15em;
  font-weight: bold;
  margin-bottom: .5em;
}
body {
  padding: 1em;
}
* {
  box-sizing: border-box;
}
"
css_value <- sass::sass(scss)

ui <- withTags(fluidPage(
  # script to change the class in the browser
  head(
    # make sure to include the compiled css!
    style(HTML(css_value)),

    # watch for the button clicks to change the theme within the browser
    script(HTML("
// when the document is ready...
$(function() {
  // when a shiny input changes...
  $(document).on('shiny:inputchanged', function(event) {
    switch (event.name) {
      // if the event name matches one of...
      case 'default':
      case 'banana':
      case 'cherry':
      case 'blueberry':
      case 'leaf':
      case 'nightsky':

        $('.demo')                          // select the main body
          .removeClass()                    // remove the class
          .addClass('demo ' + event.name);  // add the themed class

        $('.controls button').removeAttr('disabled'); // make all buttons active
        $('#' + event.name).attr('disabled', true);   // disable the most recent button

        break;
    }
  });
});
    "))
  ),

  div(class = "demo nightsky",
    div(class = "component",
      h2("Sass Color Themes"),
      ul(
        li(),
        li(),
        li(),
        li()
      )
    )
  ),
  div(class = "controls",
     actionButton("default", "Default"),
     actionButton("banana", "Funny Banana"),
     actionButton("cherry", "Hot Chery"),
     actionButton("blueberry", "Deep Purple"),
     actionButton("leaf", "Smooth Leaf"),
     actionButton("nightsky", "Night sky", disabled = "true")
  )
))

server <- function(input, output) {
  hit <- function(button, name) {
    if (button == 0) return()
    cat("Button: '", name, "' was pressed! Value: ", button, "\n", sep = "")
  }
  observe({ hit(input$default, "Default") })
  observe({ hit(input$banana, "Funny Banana") })
  observe({ hit(input$cherry, "Hot Cherry") })
  observe({ hit(input$blueberry, "Deep Purple") })
  observe({ hit(input$leaf, "Smooth Leaf") })
  observe({ hit(input$nightsky, "Night Sky") })
}

shinyApp(ui, server)

library(shiny)
library(sass)
library(colourpicker)

ui <- fluidPage(
  headerPanel("Sass Size Example"),
  uiOutput("sass"),

  sidebarPanel(
    sliderInput("width", "Image Percent of Screen",
                min = 1, max = 100, value = 100),
    colourInput("color", "Background Color", value = "#6498d2",
                showColour = "text")
  ),

  mainPanel(
    plotOutput("distPlot"),
    br()
  ),

  column(6, verbatimTextOutput("scssTxt"), verbatimTextOutput("sassFile")),
  column(6, verbatimTextOutput("cssTxt"))
)

server <- function(input, output) {
  output$distPlot <- renderPlot({
    hist(rnorm(500))
  })

  variables <- reactive({
    list(
      color = input$color,
      width = input$width
    )
  })

  sass_input <- reactive({
    list(
      variables(),
      sass_file("sass-size.scss")
    )
  })
  compiled_css <- reactive({
    sass(sass_input())
  })

  output$sass <- renderUI({
    tags$head(tags$style(compiled_css()))
  })

  output$scssTxt <- renderText({
    paste0("/* Sass */\n", as_sass(sass_input()))
  })
  output$sassFile <- renderText({
    paste0(
      "/* sass-size.scss */\n\n",
      paste0(readLines("sass-size.scss"), collapse = "\n")
    )
  })

  output$cssTxt <- renderText({
    paste0("/* Compiled CSS */\n", compiled_css())
  })
}

shinyApp(ui, server)

# Turn off the default cache until the calling function exits; when that
# happens, the previous default cache will be restored.
local_disable_cache <- function(env = parent.frame()) {
  old_opts <- options(sass.cache = FALSE)
  withr::defer(
    options(old_opts),
    envir = env
  )
}

# Creates a temporary cache that is used as the default. When the calling
# function exits, the temporary cache is destroyed, and the previous default
# cache is restored.
local_temp_cache <- function(env = parent.frame()) {
  temp_cache <- sass_file_cache(dir = tempfile())
  old_opts <- options(sass.cache = temp_cache)
  withr::defer(
    {
      options(old_opts)
      temp_cache$destroy()
    },
    envir = env
  )
}

# Disable sass cache
local_disable_cache()

test_that("unnamed options fail", {
  sass_options <- sass_options()
  names(sass_options) <- NULL
  expect_error(
    sass("foo { margin: 122px * .3; }", options = sass_options),
    "No named options"
  )
})

test_that("too few options fail", {
  sass_options <- sass_options()
  sass_options$precision <- NULL
  expect_error(
    sass("foo { margin: 122px * .3; }", options = sass_options),
    "missing"
  )
})

test_that("too many options fail", {
  sass_options <- sass_options()
  sass_options$new <- "hello"
  expect_error(
    sass("foo { margin: 122px * .3; }", options = sass_options),
    "unsupported"
  )
})

test_that("wrong options fail", {
  sass_options <- sass_options()
  sass_options$precision <- NULL
  sass_options$blah <- "hello"
  expect_error(
    sass("foo { margin: 122px * .3; }", options = sass_options),
    "precision"
  )
})

test_that("wrong type fails", {
  sass_options <- sass_options()
  sass_options$precision <- "hello"
  expect_error(
    sass("foo { margin: 122px * .3; }", options = sass_options),
    "Invalid type for precision"
  )
})

test_that("Global options work", {
  on.exit(sass_options_set(NULL), add = TRUE)

  expect_identical(sass_options_get(), sass_options())

  old_options <- sass_options_set(precision = 10)
  expect_equal(
    sass_options_get(),
    sass_options(precision = 10),
    ignore_attr = TRUE
  )

  expect_equal(
    sass_options_get(precision = 11),
    sass_options(precision = 11),
    ignore_attr = TRUE
  )

  sass_options_set(old_options)
  expect_identical(sass_options_get(), sass_options())

  sass_options_set(precision = 12)
  opts <- sass_options_get()
  sass_options_set(precision = 13)
  sass_options_set(opts)
  expect_equal(
    sass_options_get(),
    sass_options(precision = 12),
    ignore_attr = TRUE
  )

  expect_error(
    sass_options_set(1),
    "sass_options"
  )
  expect_error(
    sass_options_get(foo = "bar"),
    "foo"
  )
})

test_that("Global options work 2", {
  expect_identical(sass_options_get(), sass_options())
})

test_that("unicode variables work", {
  local_disable_cache()
  expected <- read_utf8("test-unicode-var-expected.css")
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  css <- sass(sass_file("test-unicode-var-input.scss"))

  expect_equal(css, expected)
})

test_that("unicode css works with cache enabled", {
  expected <- read_utf8("test-unicode-css-expected.css")
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  css <- sass(sass_file("test-unicode-css-input.scss"))

  expect_equal(Encoding(css), "UTF-8")
  expect_equal(css, expected)
})

test_that("unicode css works with cache disabled", {
  local_disable_cache()
  expected <- read_utf8("test-unicode-css-expected.css")
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  css <- sass(sass_file("test-unicode-css-input.scss"))

  expect_equal(Encoding(css), "UTF-8")
  expect_equal(css, expected)
})

test_that("unicode bom", {
  expected <- read_utf8("test-unicode-bom-expected.css")
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  css <- sass(sass_file("test-unicode-bom-input.scss"))

  expect_equal(css, expected)
})

# Disable sass cache
local_disable_cache()

test_that("mixins work", {
  expected_first_word <- ".box"
  css <- sass(sass_file("test-mixins.scss"))
  expect_equal(
    strsplit(css, " ")[[1]][1],
    expected_first_word
  )
})

# Disable sass cache
local_disable_cache()

test_that("writing to file works", {
  file_name <- tempfile(fileext = ".css")
  sass(
    sass_file("test-nesting-input.scss"),
    output = file_name
  )
  on.exit(unlink(file_name))
  output <- paste0(readLines(file_name), collapse = "\n")
  expected <- paste0(readLines("test-nesting-expected.css"), collapse = "\n")

  expect_true(file.exists(file_name))
  expect_equal(output, expected)
})

test_that("writing to invalid path fails", {
  expect_error(
    sass(
      sass_file("test-nesting-input.scss"),
      output = "not/path/output.txt"
    )
  )
})

# Disable sass cache
local_disable_cache()

test_that("nesting works", {
  expected <- read_utf8("test-nesting-expected.css")
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  css <- sass(sass_file("test-nesting-input.scss"))

  expect_equal(css, expected)
})

# Disable sass cache
local_disable_cache()

test_that("import works", {
  imported_type <- "html"
  css <- sass(sass_file("test-import.scss"))
  expect_equal(
    strsplit(css, ",")[[1]][1],
    imported_type
  )
})

# Disable sass cache
local_disable_cache()

test_that("indent width works", {
  scss <- "foo { margin: 122px * .3; }"
  css_default <- sass(scss)

  width <- 4
  css_width <- sass(scss, options = sass_options(indent_width = width))
  expect_equal(
    nchar(css_default) + width - 2,
    nchar(css_width)
  )
})

test_that("indent as tabs works", {
  scss <- "foo { margin: 122px * .3; }"
  css <- sass(scss, options = sass_options(indent_width = 1, indent_type = "tab"))
  expect_equal(
    strsplit(css, "")[[1]][7],
    "\t"
  )
})

test_that("linefeed works", {
  scss <- "foo { margin: 122px * .3; }"
  css_lf <- sass(scss)

  expect_equal(
    strsplit(css_lf, "")[[1]][6],
    "\n"
  )

  css_cr <- sass(scss, options = sass_options(linefeed = "cr"))

  expect_equal(
    strsplit(css_cr, "")[[1]][6],
    "\r"
  )

  css_crlf <- sass(scss, options = sass_options(linefeed = "crlf"))

  expect_equal(
    paste0(strsplit(css_crlf, "")[[1]][6:7], collapse = ""),
    "\r\n"
  )

  css_crlf <- sass(scss, options = sass_options(linefeed = "lfcr"))

  expect_equal(
    paste0(strsplit(css_crlf, "")[[1]][6:7], collapse = ""),
    "\n\r"
  )
})

test_that("precision works", {
  scss <- "foo { margin: 1px * 0.1234567891; }"
  num_chars_no_precision <- 23
  css <- sass(scss)

  expect_equal(
    num_chars_no_precision + 6,
    nchar(css)
  )

  css <- sass(scss, options = sass_options(precision = 0))
  expect_equal(
    num_chars_no_precision,
    nchar(css)
  )

  css <- sass(scss, options = sass_options(precision = 10))
  expect_equal(
    num_chars_no_precision +  11,
    nchar(css)
  )
})

test_that("source_comments work", {
  expect_lt(
    nchar(sass(sass_file("test-compile.scss"))),
    nchar(sass(sass_file("test-compile.scss"), sass_options(source_comments = TRUE)))
  )
})

test_that("throws on invalid output dir", {
  local_temp_cache()

  # Prime the cache
  sass("div { border: 1px solid black; }")

  # Cache
  expect_error(
    sass(
      "div { border: 1px solid black; }",
      output = file.path("not", "a", "path.css")
    )
  )
})

test_that("reads from and writes to cache", {
  local_temp_cache()
  expected <- read_utf8("test-unicode-var-expected.css")

  # Wrap the sass_file up into a bundle to ensure it's attribute
  # doesn't get dropped when the bundle is collapsed (into a layer) and compiled
  input <- sass_bundle(sass_layer(rules = sass_file("test-unicode-var-input.scss")))

  expect_equal(as.character(sass(input)), expected)

  expect_equal(as.character(sass(input)), expected)

  expect_equal(sass_cache_get()$size(), 1)

  # Modifying the file busts the cache (even it if has the same contents)
  Sys.setFileTime("test-unicode-var-input.scss", Sys.time() + 5)
  expect_equal(as.character(sass(input)), expected)
  expect_equal(sass_cache_get()$size(), 2)
})

test_that("writes to cache", {

  expect_cached <- function(input, css) {
    local_temp_cache()
    cache <- sass_cache_get()
    # Allow input to be an expression, like layer(), that can generate
    # different input everytime it gets evaluated
    input_code <- substitute(input)
    # Did we get the right CSS result?
    expect_css(eval(input_code), css)
    # Did a cache entry get added?
    expect_equal(cache$size(), 1)
    # Compile again, now with an output file
    out_file <- tempfile(fileext = ".css")
    expect_css(eval(input_code), css, output = out_file)
    # If there was a cache hit, the size should be the same
    expect_equal(cache$size(), 1)
    # Now manipulate the cache directly to make sure it is actually being read
    # from. We'll change the value in the cache and see if sass() reads from it.
    cache$set_content(cache$keys(), "foo")
    expect_css(eval(input_code), "foo")
  }

  expect_cached(
    list(
      list(text_color = "#313131"),
      list("body { color: $text_color; }")
    ),
    "body{color:#313131;}"
  )

  # Make sure cache key doesn't change with new/temporary HTML dependencies
  my_layer <- function() {
    src <- tempfile()
    dir.create(src)
    sass_layer(
      "@function fib($x) {
         @if $x <= 1 {
           @return $x
         }
         @return fib($x - 2) + fib($x - 1);
       }
       body { width: fib(27);}",
      html_deps = htmltools::htmlDependency("foo", "1.0", src)
    )
  }

  expect_cached(
    my_layer(),
    "body{width:196418;}"
  )

})

test_that("unicode characters work OK after caching", {
  local_temp_cache()
  expected <- read_utf8("test-unicode-var-expected.css")
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  css <- sass(sass_file("test-unicode-var-input.scss"))
  expect_equal(css, expected)

  css <- sass(sass_file("test-unicode-var-input.scss"))
  expect_equal(css, expected)

  expect_equal(sass_cache_get()$size(), 1)
})

test_that("cache isn't written if a compilation error occurs", {
  local_temp_cache()

  input <- list(
    list(text_color = "#a0a0a0"),
    list("body { color is: $text_color; }")
  )
  options <- sass_options(output_style = "compact")

  expect_error(sass(input, options), "must be followed")

  expect_equal(sass_cache_get()$size(), 0)
})

test_that("cache key components", {
  tmpfile <- tempfile(fileext = ".tmp")
  file.create(tmpfile)
  old_mtime <- file.mtime(tmpfile)

  input <- list(sass_file(tmpfile))
  options <- sass_options()

  key1 <- sass_hash(list(input, options))
  while (file.mtime(tmpfile) == old_mtime) {
    # Force timestamp to change
    Sys.sleep(0.1)
    file.remove(tmpfile)
    file.create(tmpfile)
  }

  # Files differing by mtime should have different keys
  key2 <- sass_hash(list(input, options))
  expect_true(key1 != key2)

  # Options that are identical should have same key
  options3 <- sass_options()
  key3 <- sass_hash(list(input, options3))
  expect_true(key2 == key3)

  # Options that are different should have different keys
  options4 <- sass_options(output_style = "compact")
  key4 <- sass_hash(list(input, options4))
  expect_true(key3 != key4)
})



test_that("output_template() is cache and options aware", {
  local_temp_cache()

  input <- list(
    list(color = "red"),
    "body{color:red}"
  )
  opts <- sass_options(output_style = "compressed")
  expect_red <- function(file) {
    expect_equal(
      "body{color:red}",
      gsub("(\\s+)|(\t)|(;)", "", paste(readLines(file), collapse = ""))
    )
  }

  # File is exactly the same with the same input+options
  output1 <- sass(input, output = output_template(), options = opts)
  output2 <- sass(input, output = output_template(), options = opts)
  expect_true(output1 == output2)
  expect_match(output1, ".min.css$")
  expect_red(output1)
  expect_red(output2)

  # If cache is different, should get a different output file
  output3 <- sass(input, output = output_template(), options = opts, cache_key_extra = "foo")
  expect_true(output1 != output3)
  expect_red(output3)

  # Not minimized by default (because output_style = "expanded")
  output4 <- sass(input, output = output_template())
  expect_false(grepl(".min.css$", output4))
  expect_red(output4)

  # If no caching, should get a different output files
  output5 <- sass(input, output = output_template(), cache = FALSE)
  output6 <- sass(input, output = output_template(), cache = FALSE)
  expect_true(dirname(output5) != dirname(output6))
  expect_red(output5)
  expect_red(output6)

  # File can be written in another dir and still be cache aware
  temp_dir <- withr::local_tempdir()
  output7 <- sass(input, output = output_template(path = temp_dir), options = opts)
  expect_true(basename(dirname(dirname(output7))) == basename(temp_dir))
  expect_true(basename(dirname(output7)) == basename(dirname(output1)))
})

test_that("Cache directory getting/setting", {
  cache_dir <- tempfile("sass-cache-test-")
  cache <- sass_file_cache(dir = cache_dir)

  # Can normalize path _after_ dir is created.
  cache_dir <- normalizePath(cache_dir)
  expect_identical(normalizePath(cache$dir()), cache_dir)

  # Setting the cache for a directory works
  sass_cache_set_dir(cache_dir, cache)
  expect_identical(sass_cache_get_dir(cache_dir), cache)

  # It checks that the specified dir and the cache's dir match
  expect_error(sass_cache_set_dir(file.path(cache_dir, "foo"), cache))

  # Check that the path is normalized. Create another cache object and set
  # it as the cache for this path. Then fetching the cache for the path should
  # return the new one.
  cache2 <- sass_file_cache(dir = cache_dir)
  expect_false(identical(cache, cache2))
  sass_cache_set_dir(
    file.path(cache_dir, "..", basename(cache_dir)),
    cache2
  )
  expect_identical(sass_cache_get_dir(cache_dir), cache2)

  # Can unset cache for a given directory
  sass_cache_set_dir(cache_dir, NULL)
  expect_false(exists(cache_dir, envir = .caches))

  # Calling sass_cache_get_dir() when it doesn't exist should error
  cache_dir <- tempfile("sass-cache-test-")
  expect_error(sass_cache_get_dir(cache_dir))

  # Calling sass_cache_get_dir() when the dir exists but no cache object has
  # been registered returns NULL
  dir.create(cache_dir)
  expect_null(sass_cache_get_dir(cache_dir))


  # Calling sass_cache_get_dir() when the dir doesn't exist (and cache object
  # isn't registered) with create=TRUE should create the dir and the cache
  # object.
  cache_dir <- tempfile("sass-cache-test-")
  cache_obj <- sass_cache_get_dir(cache_dir, create = TRUE)
  expect_true(dir.exists(cache_dir))
  expect_true(inherits(cache_obj, "FileCache"))

  # Calling sass_cache_get_dir() when the dir exists but cache object does not
  # with create=TRUE should create the cache object.
  cache_dir <- tempfile("sass-cache-test-")
  dir.create(cache_dir)
  cache_obj <- sass_cache_get_dir(cache_dir, create = TRUE)
  expect_true(dir.exists(cache_dir))
  expect_true(inherits(cache_obj, "FileCache"))
})


test_that("Can pass a cache directory to sass()", {
  cache_dir <- tempfile()
  sass("body {color: red; }", cache = cache_dir)

  # Cache directory should have been created
  cache_obj <- sass_cache_get_dir(cache_dir, create = FALSE)
  expect_true(inherits(cache_obj, "FileCache"))
})

# Disable sass cache
local_disable_cache()

library(htmltools)
dep1 <- htmlDependency(
  name = "fake1",
  version = "1.0.0",
  src = ""
)
dep2 <- htmlDependency(
  name = "fake2",
  version = "1.0.0",
  src = ""
)

test_that("sass()/as_sass() relay html dependencies", {
  scss <- attachDependencies(list("body{color: green}"), dep1)
  # Test that the print methods also relay
  expect_snapshot(sass(scss), cran = TRUE)
  expect_snapshot(as_sass(scss), cran = TRUE)
  tmpcss <- tempfile(fileext = ".css")
  on.exit(unlink(tmpcss), add = TRUE)
  expect_equal(htmlDependencies(sass(scss)), list(dep1))
})

test_that("sass() relays sass_layer()'s html dependencies", {
  layer1 <- sass_layer(defaults = "body{color: green}", html_deps = dep1)
  input1 <- list(layer1, "body{color: red}")
  expect_equal(htmlDependencies(sass(input1)), list(dep1))
  layer2 <- sass_layer(defaults = "body{color: blue}", html_deps = dep2)
  input2 <- sass_bundle(layer1, layer2)
  expect_equal(htmlDependencies(sass(input2)), list(dep1, dep2))
})

# Disable sass cache
local_disable_cache()

assets <- normalizePath(testthat::test_path("test-assets"), mustWork = TRUE)

blue <- list(color = "blue !default")
red <- list(color = "red !default")
green <- list(color = "green !default")
core <- sass_layer(
  defaults = blue,
  functions = "@function my_invert($color, $amount: 100%) {
    $inverse: change-color($color, $hue: hue($color) + 180);
    @return mix($inverse, $color, $amount);
  }",
  rules = "body { background-color: $color; color: my_invert($color); }"
)

test_that("sass_layer is equivalent to sass", {
  expect_equal(
    sass(core),
    sass(list(blue, "body { background-color: $color; color: yellow; }")),
    ignore_attr = TRUE
  )
})

test_that("sass layer format", {
  expect_snapshot(format(core))
  expect_snapshot(core)

  layer1 <- sass_layer(
    file_attachments = c(
      file.path(assets, "a.txt")
    )
  )

  core_extra <- sass_bundle(core, layer1)
  expect_output(
    print(core_extra),
    "Other Sass Bundle information:"
  )
})

test_that("sass_bundle() works as intended", {
  red_layer <- sass_layer(red, rules = ":root{ --color: #{$color}; }")
  expect_equal(
    sass(list(red, core, ":root{ --color: #{$color}; }")),
    sass(sass_bundle(core, red_layer)),
    ignore_attr = TRUE
  )
})

test_that("sass_bundle_remove() will remove all layers", {

  obj <-
    sass_bundle(
      sass_bundle(core, red = ":root{ --color: #{$color}; }"),
      green = sass_layer(green)
    )

  obj_slim <- sass_bundle_remove(obj, "red")
  expected <- sass_bundle(core, green = sass_layer(green))
  expect_identical(obj_slim, expected)

  just_core <- sass_bundle_remove(obj, c("green", "red"))
  only_core <- sass_bundle(core)
  expect_identical(just_core, only_core)

  expect_equal(
    names(obj$layers),
    c("", "red", "green")
  )
  expect_equal(
    names(expected$layers),
    c("", "green")
  )

  expect_true(is_sass_bundle(obj_slim))
  expect_true(is_sass_bundle(expected))
})

test_that("additional merging features", {
  layer1 <- sass_layer(
    file_attachments = c(
      file.path(assets, "a.txt")
    )
  )

  layer2 <- sass_layer(
    file_attachments = c(
      "b/b1.txt" = file.path(assets, "b/b1.txt")
    )
  )

  layer_merged <- as_sass_layer(sass_bundle(layer1, layer2))
  expect_identical(
    layer_merged$file_attachments,
    c(
      file.path(assets, "a.txt"),
      "b/b1.txt" = file.path(assets, "b/b1.txt")
    )
  )
})

test_that("file attachments are written", {
  layer1 <- sass_layer(
    rules = "body { background-color: $body-bg; }",
    file_attachments = c(
      "assets/txt/a.txt" = file.path(assets, "a.txt")
    )
  )

  input <- list(
    list("body-bg" = "silver"),
    layer1
  )

  expect_error(
    sass(input, write_attachments = TRUE),
    "cannot be used when output=NULL"
  )

  expect_warning(sass(input), NA)

  tmpdir <- tempfile()
  stopifnot(nzchar(tmpdir)) # Precaution because we'll `rm -rf` this later
  on.exit(unlink(tmpdir, recursive = TRUE), add = TRUE)

  dir.create(tmpdir)

  sass(input,
    output = file.path(tmpdir, "styles.css"),
    write_attachments = TRUE)

  expect_true(
    file.exists(file.path(tmpdir, "assets/txt/a.txt"))
  )

  # the default for write_attachments warns if file attachments are present
  expect_warning(
    sass(input, output = file.path(tmpdir, "styles1.css")),
    "file attachments that are being ignored"
  )
  # when write_attachments = FALSE, the warning is suppressed
  expect_warning(
    sass(input, output = file.path(tmpdir, "styles1.css"), write_attachments = FALSE),
    NA
  )

})

test_that("write_file_attachments edge cases", {
  tmpdir <- tempfile()
  stopifnot(nzchar(tmpdir)) # Precaution because we'll `rm -rf` this later

  dir.create(tmpdir)
  oldwd <- getwd()
  setwd(tmpdir)
  on.exit({
    setwd(oldwd)
    unlink(tmpdir, recursive = TRUE)
  }, add = TRUE)

  # === Failures ===========

  dir.create("test0")

  # Relative dest path points upward
  expect_error(write_file_attachments(
    c("foo/../../bar" = file.path(assets, "a.txt")),
    output_path = "test0"
  ), "Illegal file attachment destination")

  # Relative source path not allowed
  expect_error(write_file_attachments(
    c("test0"),
    output_path = "test0"
  ), "must be absolute")

  # File attachment must exist
  expect_error(write_file_attachments(
    c("a.txt" = "/weflkjwkefjeg.txt"),
    output_path = "test0"
  ), "must exist")

  # === Successes ===========

  dir.create("test1")
  write_file_attachments(
    c(
      "files/A" = file.path(assets, "a.txt"),
      "files/B" = file.path(assets, "b/b1.txt"),
      "C" = file.path(assets, "c")
    ),
    "test1"
  )
  expect_identical(
    sort(list.files("test1", all.files = TRUE, recursive = TRUE)),
    c("C/c1.txt", "C/d/d1.txt", "files/A", "files/B")
  )

  dir.create("test2")
  write_file_attachments(
    c(
      "a1" = file.path(assets, "a.txt"),
      "a2/" = file.path(assets, "a.txt"),
      file.path(assets, "b"),
      "c1/" = file.path(assets, "c"),
      "c2" = file.path(assets, "c"),
      "c3/" = file.path(assets, "c/"),
      "c4" = file.path(assets, "c/")
    ),
    "test2"
  )
  expect_identical(
    sort(list.files("test2", all.files = TRUE, recursive = TRUE)),
    c(
      "a1",
      "a2/a.txt",
      "b1.txt",
      "c1/c1.txt", "c1/d/d1.txt",
      "c2/c1.txt", "c2/d/d1.txt",
      "c3/c1.txt", "c3/d/d1.txt",
      "c4/c1.txt", "c4/d/d1.txt"
    )
  )
})



test_that("sass_layer_file() basically works", {
  f <- file.path(assets, "test-layer-file.scss")
  expect_snapshot(str(sass_layer_file(f)))
})

# Disable sass cache
local_disable_cache()

test_that("has_any_name finds names", {

  expect_true(has_any_name(list(a = 4, 5)))
  expect_true(has_any_name(list(4, a = 5)))
  expect_true(has_any_name(list(a = 4, b = 5)))

  expect_false(has_any_name(list(4, 5)))
})

test_that("has_any_name_recursive finds names", {

  expect_true(has_any_name_recursive(list(a = 4, 5)))
  expect_true(has_any_name_recursive(list(4, a = 5)))
  expect_true(has_any_name_recursive(list(a = 4, b = 5)))

  expect_true(has_any_name_recursive(list(list(list(list(list(c(a = 4))))))))
  expect_true(has_any_name_recursive(list(1,2, list(a = 4, 5), 4)))
  expect_true(has_any_name_recursive(list(1,2, list(4, a = 5), 4)))

  expect_false(has_any_name_recursive(4))
  expect_false(has_any_name_recursive(list(list(list(list(list(4)))))))
  expect_false(has_any_name_recursive(list(list(list(list(list(4, 5, 6, 7)))))))
})


test_that("join_non_null_values combines null elements as expected", {

  obj <- sass_bundle(
    ".rule-a {}", # sass rule
    list(color = "blue"), # sass default
    sass_layer(mixins = ".rule-b {}"),
    ".rule-c {}", # sass rule
  )
  expected <- sass_layer(
    defaults = list(color = "blue"),
    mixins = ".rule-b {}",
    rules = list(".rule-a {}", ".rule-c {}")
  )

  expect_equal(as_sass(obj), as_sass(expected))
  expect_snapshot(obj)
})


test_that("bundle like objects can be detected", {

  sass_item <- sass_layer("body {}")
  expect_equal(find_bundle_or_layer(list(list(list(4, 5, 6, list(sass_item), 7)))), sass_item)
  expect_equal(find_bundle_or_layer(list(list(list(4, 5, 6, sass_item, 7)))), sass_item)
  expect_equal(find_bundle_or_layer(list(list(list(4, 5, 6, sass_item, 7)))), sass_item)
  expect_equal(find_bundle_or_layer(list(list(list(4, 5, 6, as_sass_layer(sass_item), 7)))), as_sass_layer(sass_item))

  expect_equal(find_bundle_or_layer(list(list(list(4, 5, 6, 10, 7)))), NULL)

  my_layer <- sass_layer(rules = "body {}")
  expect_error(
    sass_layer(defaults = list(1, 2, my_layer, 4)),
    "`sass_layer(defaults)` can not contain", fixed = TRUE
  )
  expect_error(
    sass_layer(functions = list(1, 2, my_layer, 4)),
    "sass_layer(functions)` can not contain", fixed = TRUE
  )
  expect_error(
    sass_layer(mixins = list(1, 2, my_layer, 4)),
    "sass_layer(mixins)` can not contain", fixed = TRUE
  )
  expect_error(
    sass_layer(rules = list(1, 2, my_layer, 4)),
    "sass_layer(rules)` can not contain", fixed = TRUE
  )
})

# Disable sass cache
local_disable_cache()

test_that(".scss file compiles", {
  expected <- "foo {\n  margin: 36.6px;\n}\n\nbar {\n  margin: 63px;\n}\n"
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  expect_equal(
    sass(sass_file("test-compile.scss")),
    expected
  )
})

test_that("string input compiles", {
  expected <- "foo {\n  margin: 36.6px;\n}\n"
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  expect_equal(
    sass("foo { margin: 122px * .3; }"),
    expected
  )
})

test_that("character vector input compiles", {
  input <- c(".foo {\n  color: red;\n}\n", ".bar {\n  background-color: blue;\n}\n")
  expected <- paste(input, collapse = "\n")
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  expect_equal(sass(input), expected)
  expect_equal(sass(as.list(input)), expected)
})

test_that("named character vector throws warning", {
  expect_warning(sass(c(var = "foo{color: red}")), "named")
})

test_that("sass compiles", {
  expected <- "foo {\n  margin: 36.6px;\n}\n\nbar {\n  margin: 63px;\n}\n"
  class(expected) <- c("css", "html", "character")
  attr(expected, "html") <- TRUE

  expect_equal(
    sass(sass_file("test-compile.sass"), sass_options(indented_syntax = TRUE)),
    expected
  )
})


test_that("sass_partial() and sass() arguments match", {
  s <- formals(sass)
  s$input <- NULL

  sp <- formals(sass_partial)
  sp$rules <- NULL
  sp$bundle <- NULL

  expect_identical(s, sp)
})

compressed_css <- function(x) {
  gsub("\\s+|\\n", "", paste(as.character(x), collapse = ""))
}

expect_css <- function(input, css, output = NULL, ...) {
  res <- sass(input, output = output, ...)
  if (!is.null(output)) {
    res <- read_utf8(res)
  }
  expect_identical(
    compressed_css(res),
    compressed_css(css)
  )
}

---
title: "Overview of the sass R package"
author: "Carson Sievert"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Overview of the sass R package}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

<style>
pre {
  border: 1px solid #eee;
}

pre.r {
  background-color: #ffffff;
  margin-bottom: -0.5em;
}

pre.r code {
  background-color: #ffffff;
}

pre.css {
  background-color: #f8f8f8;
  border-radius: 0;
  border-bottom-left-radius: 4px;
  border-bottom-right-radius: 4px;
}
</style>



## Why Sass? {#why}

[Sass](https://sass-lang.com/) is the most widely used, feature rich, and stable CSS extension language available. It has become an essential tool in modern web development because of its ability to _reduce complexity_ and _increase composability_ when styling a website. For a basic example, suppose you want to use the same color for multiple styling rules in your website (e.g., hyperlinks and buttons). With CSS, you'd have to repeat that color every time it is used in styling rule, so in a large project, changing at a later point can be tedious and error-prone.

```css
a {
  color: salmon;
}
button {
  background-color: salmon;
}
```

With Sass, you could store this color in a Sass variable and use it in the styling rules to produce the same CSS, resulting in a single entry point for the color's value. This simple Sass tool can make CSS styling a lot easier to reason about, making styles a lot easier to customize and maintain.

```css
$main-color: salmon;
a {
  color: $main-color;
}
button {
  background-color: $main-color;
}
```

Sass variables are not the only Sass tool useful for reducing complexity. For Sass and **sass** newcomers, this vignette first covers how to use basic Sass tools like [variables](#variables), [mixins](#mixins), and [functions](#functions) in the **sass** R package. After the basics, you'll also learn how to write [composable **sass**](#layering) that allows users to easily override your styling defaults and developers to [include](#includes) your Sass in their styling projects. You'll also learn how to control the CSS output (e.g., [compress](#compression) and [cache](#caching) it), and how to use it in [**shiny**](#shiny) & [**rmarkdown**](#rmarkdown).

By mastering these concepts, you'll not only be able to leverage the advantages of using Sass over CSS, but you'll also have the basis needed to develop R interfaces to Sass projects that allow users to easily customize your styling templates _without any knowledge of Sass/CSS_. For an example, see the [**bslib** R package](https://github.com/rstudio/bslib), which provides a interface to [Bootstrap Sass](https://getbootstrap.com/docs/4.0/getting-started/theming/) through easy-to-use functions like `bs_theme_add_variables()`.

## Sass Basics {#basics}

```{r setup, include=FALSE}
library(sass)
knitr::opts_chunk$set(
  collapse = TRUE,
  message = FALSE,
  fig.align = "center",
  out.width = "80%",
  class.output = "css",
  comment = ""
)
```

### Variables {#variables}

[Sass variables](https://sass-lang.com/guide#topic-2) are a great mechanism for simplifying and exposing CSS logic to users. To create a variable, assign a value (likely a CSS [property value](https://developer.mozilla.org/en-US/docs/Learn/Getting_started_with_the_web/CSS_basics)) to a name, then refer to it by name in downstream Sass code. In this minimal example, we create a `body-bg` variable then use it to generate a single [style rule](https://sass-lang.com/documentation/style-rules), but as we'll see later, variables can also be used inside of other arbitrary Sass code (e.g., functions, mixins, etc).

```r
library(sass)
variable <- "$body-bg: red;"
rule <- "body { background-color: $body-bg; }"
sass(input = list(variable, rule))
```

```css
/* CSS */
body { 
  background-color: red;
}
```

A more convenient and readable way to create Sass variables in R is to use a named `list()`. Also, it's a good idea to add the ` !default` flag after the value since it provides users of your Sass an opportunity to set their own value. We'll learn more about defaults in [layering](#layering), but for now, just note that the `!default` flag says use this value only if that variable isn't already defined:

```r
user_default <- list("body-bg" = "blue !default")
default <- list("body-bg" = "red !default")
sass(input = list(user_default, default, rule))
```

```css
/* CSS */
body { 
  background-color: blue;
}
```

### Functions {#functions}

Sass comes with a variety of [built-in functions](https://sass-lang.com/documentation/modules) (i.e., you don't have to [import](#imports) anything to start using them) which are useful for working with CSS values ([colors](https://sass-lang.com/documentation/modules/color), [numbers](https://sass-lang.com/documentation/modules/math), [strings](https://sass-lang.com/documentation/modules/string), etc). These built-in functions are primarily useful modifying or combining CSS values in such a way that isn't possible with CSS. Here we use the `rgba()` to add alpha blending to `black` and assign the result to a variable.^[Oh, by the way, the value of a variable may be an expression.]

```r
variable <- list("body-bg" = "rgba(black, 0.8)")
sass(input = list(variable, rule))
```

```css
/* CSS */
body {
  background-color: rgba(0, 0, 0, 0.8);
}
```

Sass also provides the ability to define your own functions through the [`@function` at-rule](https://sass-lang.com/documentation/at-rules/function). Like functions in most languages, there are four main components to a function definition: (1) the function `name`, (2) the function argument/inputs (e.g., `arg1`, `arg2`), (3) the function body which contains statements (i.e., `statement1`, `statement2`, etc.), and finally (4) a return `value`.

```r
@function name(arg1, arg2) {
  statement1;
  statement2;
  @return value;
}
```

<br>

For an example of where creating your function becomes useful, consider this `color-contrast()` function, inspired by [this SO answer](https://stackoverflow.com/questions/3942878/how-to-decide-font-color-in-white-or-black-depending-on-background-color/3943023#3943023) to a common problem that arises when allowing users control over background color of something (e.g., the document body). We'd like to strive for styling rules that are smart enough to overlay white text on a dark colored background and black text on a light colored background. `color-contrast()` helps us achieve this since, given a dark color, it returns white; and given a light color, it returns black.

```r
@function color-contrast($color) {
  @return if(
    red($color) * 0.299 + green($color) * 0.587 + blue($color) * 0.114 > 186,
    black, white
  );
}
```

<br>

By saving this function to a file named `color-contrast.scss`, it can then be [imported](#imports) and used in the following way. For a live example of this in action, consider [this Shiny app](https://gallery.shinyapps.io/sass-font/) which allows the user to interactively choose a background color and the title's font color automatically updates to an appropriate color contrast. [See here](#shiny-dynamic) for more on allowing **shiny** users to influence styling on the page using **sass**.

```r
sass(
  list(
    variable,
    sass_file("color-contrast.scss"),
    "body {
      background-color: $body-bg;
      color: color-contrast($body-bg);
    }"
  )
)
```

```css
/* CSS */
body {
  background-color: rgba(0, 0, 0, 0.8);
  color: white;
}
```

**NOTE**: `bslib::bs_theme()` provides it's own, more sophisticated, version of `color-contrast()` that you can use like so:  `sass::sass_partial("body{color: color-contrast($body-bg)}", bs_theme())`

```{r, eval=FALSE, ref.label='bs_sass'}
```

### Importing {#imports}

In practice, you'll want to write your Sass code in `.scss` ([or `.sass`](https://sass-lang.com/documentation/syntax)) files (instead of inside R strings). That way you can leverage things like syntax highlighting in RStudio (or your favorite IDE) and make it easier for others to import your Sass into their workflow. For example, if I have `.scss` file in my working directory, say `my-style.scss`, I can compile it this way:

```r
sass(sass_file("my-style.scss"))
```

```{r, echo = FALSE, out.width='50%'}
knitr::include_graphics('my-style.png')
```

```css
/* CSS */
body {
  background-color: rgba(0, 0, 0, 0.8);
}
```

This works because `sass_file()` uses `sass_import()` to generate an `@import` at-rule. If you visit the [docs for `@import`](https://sass-lang.com/documentation/at-rules/import), you'll notice there's more you can do that import local `.scss`, like import local or remote `.css` files, import font files, and more. Note also that `{sass}` also provides tools that make importing of local font files easier -- see `font_google()` to learn more.

## Font imports {#file-import}

Importing font file(s) directly in Sass/CSS/HTML can be a headache to implement. This is especially true if you want to serve font files so that a custom font renders on any client machine, even if the client is without an internet connection. To make this easier, `{sass}` provides a `font_google()` which can be used to download, cache, import, and serve the relevant font files all at once.

```r
library(htmltools)

my_font <- list("my-font" = font_google("Pacifico"))
css <- sass(
  list(
    my_font,
    list("body {font-family: $my-font}")
  )
)

shinyApp(
  fluidPage(
    "Hello",
    tags$style(css)
  ), 
  function(...) {}
)
```

```{r, echo = FALSE, out.width='30%'}
knitr::include_graphics('hello-pacifico.png')
```

To import non-Google fonts, use either `font_link()` or `font_face()`. The former is for importing fonts via a remote URL whereas the former could be use to import any font locally (or remotely).

### Mixins {#mixins}

Similar to how functions are useful for encapsulating _computation_ in a reusable unit, [mixins](https://sass-lang.com/documentation/at-rules/mixin) are useful for doing the same with _styling rules_ (i.e., packaging them into a reusable unit).
Technically speaking, mixins are similar to functions in that they require a `name`, may have arguments, as well as any number of statements. However, they differ in that they require the return value to be a [style rule](https://sass-lang.com/documentation/style-rules), and when called, need to be `@include`d in a larger style rule in order to generate any CSS.

For some examples, please see the [Sass mixin documentation](https://sass-lang.com/documentation/at-rules/mixin).

### More basics

This vignette intentionally doesn't try to re-invent the existing and wonderful [Sass documentation](https://sass-lang.com/documentation). There you'll find many more useful things as you start to write more Sass, such as [control flow](https://sass-lang.com/documentation/at-rules/control), [lists](https://sass-lang.com/documentation/values/lists), [maps](https://sass-lang.com/documentation/values/maps), [interpolation](https://sass-lang.com/documentation/interpolation), and more.

## Composable sass {#layering}

To make Sass code more composable with other Sass code (e.g., allowing others to change your variable defaults or import a function or mixin you've defined), consider partitioning your Sass code into a `sass::sass_layer()`. The main idea is to split your Sass into 4 parts: [`functions`](#functions), `defaults` (i.e. [variable defaults](#variables)), [`mixins`](#mixins), and `rules` (i.e., styling rules).

```r
layer1 <- sass_layer(
  functions = sass_file("color-contrast.scss"),
  defaults = list("body-bg" = "black !default"),
  rules = "body{background-color: $body-bg; color: color-contrast($body-bg)}"
)
as_sass(layer1)
```

```css
/* CSS */
body {
  background-color: black;
  color: white;
}
```

This allows downstream `sass_layer()`s to be `sass_bundle()`d into a single layer, where `defaults` in downstream layers are granted higher priority. More specifically, this means:

* `defaults` for `layer2` are placed _before_ `defaults` for `layer1`.
  * Allowing downstream Sass to override variable defaults in upstream Sass.
* `rules` for `layer2` are placed _after_ `rules` for `layer1`.
  * Allows downstream rules to take precedence over upstream rules ([precedence](https://css-tricks.com/precedence-css-order-css-matters/) matters when there are multiple rules with the same level of [specificity](https://css-tricks.com/specifics-on-css-specificity/)).

```r
layer2 <- sass_layer(
  defaults = list("body-bg" = "white !default")
)
sass(sass_bundle(layer1, layer2))
```

```css
/* CSS */
body {
  background-color: white;
  color: black;
}
```

### Resolving relative imports {#imports-relative}

Another problem that `sass_layer()` helps solve is that sometimes your Sass code might want to [import](#imports) a local file using a relative path that _you_ know how to resolve, but not necessarily the person who eventually compiles your Sass. To solve this issue, provide a named character vector to `file_attachments`, pointing the relevant relative path(s) to the appropriate absolute path(s). Here's a contrived example of how that might look ([here's](https://github.com/rstudio/bslib/blob/9c973e9/R/layers.R#L75-L77) a more real example of using it in an R package).

```r
sass_layer(
  declarations = "@import url('fonts/Source_Sans_Pro_300.ttf')",
  file_attachments = c(
    fonts = '/full/path/to/my/local/fonts'
  )
)
```

### Attaching HTML dependencies {#html-dependencies}

Another problem that `sass_layer()` helps solve is that sometimes you want to attach other HTML dependencies to your Sass/CSS (e.g., JavaScript, other CSS, etc). For this reason, `sass_layer()` has a `html_deps` argument to which you can provide `htmltools::htmlDependency()` objects. `sass()` preserves these, as well as any other HTML dependencies attached to it's input, by including them in the return value. This ensures that, when you include `sass()` in [**rmarkdown**](#rmarkdown) or [**shiny**](#shiny-string) those dependencies come along for the ride.

**DISCLAIMER**: If you want to use this feature _and_ include [CSS as a file in shiny](#shiny-file), you'll need to call `htmltools::htmlDependencies()` on the return value of `sass()` to get the dependencies, then include them in your user interface definition.

## CSS output options {#options}

The `sass()` function provides a few arguments for controlling the CSS output it generates, including `output`, `options`, and `cache_options`. The following covers some of the most important options available.

### Output to a file {#output-file}

If the CSS generated from `sass()` can be useful in more than one place, consider writing it to a file (instead of returning it as a string). To write CSS to a file, give a suitable file path to `sass()`'s `output` argument.

```r
sass(
  sass_file("my-style.scss"),
  output = "my-style.css"
)
```

### Compression {#compression}

By default, `sass()` outputs `'expanded'` CSS meaning there are lots of white-space and line-breaks included to make it more readable by humans. Computers don't need all those unnecessary characters, so to speed up your page load time when you go to include the CSS in [**shiny**](#shiny) or [**rmarkdown**](#rmarkdown), consider removing them altogether with `output_style = "compressed"`:

```r
sass(
  sass_file("my-style.scss"),
  options = sass_options(output_style = "compressed")
)
```

### Source maps {#source-maps}

When compressing the CSS output, it can be useful to include a [source map](http://www.richfinelli.com/what-is-a-css-source-maps/) so that it's easier to inspect the CSS from the website. The easiest way to include a source map is to set `source_map_embed = TRUE`:

```r
sass(
  sass_file("my-style.scss"),
  options = sass_options(
    output_style = "compressed",
    source_map_embed = TRUE
  )
)
```

### Caching {#caching}

Sometimes calling `sass()` can be computationally expensive, in which case, it can be useful to leverage its caching capability. Caching is enabled by default, unless Shiny's Developer Mode (`shiny::devmode()`) is enabled. To explicitly enable (disable), set `options(sass.cache = )` to `TRUE` (or `FALSE`):

```r
withr::with_options(
  list(sass.cache = TRUE),
  sass(sass_file("my-style.scss"))
)
```

You can also configure the location, size, and age of file caching via `sass_file_cache()`, which can be passed directly to a `sass()` call:

```r
sass(
  sass_file("my-style.scss"),
  cache = sass_file_cache(getwd(), max_size = 100 * 1024^2)
)
```

Or used with `sass_cache_set_dir()` to configure the file cache globally:

```r
sass_cache_set_dir(getwd(), sass_file_cache(getwd(), max_size = 100 * 1024^2))
```

Note that the location of the file cache defaults to `sass_cache_context_dir()`, which depends on the context in which it's running. When inside a Shiny app, the cache location is relative to the app's directory so the cache can persist and be shared across R processes. Otherwise, the context directory is a OS and package specific caching directory.

## In shiny {#shiny}

There are two basic approaches to including the CSS that `sass()` returns as HTML
in your **shiny** app. If you're curious, the official [shiny article on CSS](https://shiny.rstudio.com/articles/css.html) has more details with a couple different approaches. Regardless of the approach, consider leveraging [compressing](#compression) and [caching](#caching) the CSS output to make your app faster to load.

### As a string {#shiny-string}

The character string that `sass()` returns is already marked as `HTML()`^[Including [dynamic user input](#shiny-dynamic) directly as `HTML()`, especially with free form inputs like `textInput()`, is a security vulnerability. Avoid it if you can.], so to include it in your **shiny** app, wrap it in a `<style>` tag. It's not necessary to place this tag in the `<head>` of the document, but it's good practice:

```r
library(shiny)
css <- sass(sass_file("my-style.scss"))
fluidPage(
  tags$head(tags$style(css),
  ...
)
```

### As a file {#shiny-file}

To write CSS to a file, give a suitable file path to `sass()`'s `output` argument. Here we write to a specially named `www/` subdirectory so that **shiny** will automatically make those file(s) available to the web app.

```r
library(shiny)
sass(
  sass_file("my-style.scss"),
  output = "www/my-style.css"
)
fluidPage(
  tags$head(
    tags$link(href = "my-style.css", rel = "stylesheet", type = "text/css")
  ),
  ...
)
```

### As a dynamic input {#shiny-dynamic}

Sometimes it's useful to allow users of your **shiny** app to be able to influence your app's styling via **shiny** input(s). One way this can be done is via [dynamic UI](https://shiny.rstudio.com/articles/dynamic-ui.html), where you use `renderUI()`/`uiOutput()` to dynamically insert [CSS as an HTML string](#shiny-string) whenever a relevant input changes. Be aware, however, that whenever you allow dynamic user input to generate `HTML()`, you're leaving yourself open to security vulnerabilites; so try to avoid it, and _never_ allow clients to enter free form `textInput()` without any sort of sanitation of the user input.

Consider this basic example of using a `colourInput()` widget (from the **colourpicker** package) to choose the body's background color, which triggers a call to `sass()`:

```r
library(shiny)

ui <- fluidPage(
  headerPanel("Sass Color Example"),
  colourpicker::colourInput("color", "Background Color", value = "#6498d2", showColour = "text"),
  uiOutput("sass")
)

server <- function(input, output) {
  output$sass <- renderUI({
    tags$head(tags$style(css()))
  })
  css <- reactive({
    sass::sass(list(
      list(color = input$color),
      "body { background-color: $color; }"
    ))
  })
}

shinyApp(ui, server)
```

<br>

```{r, echo = FALSE}
knitr::include_graphics("https://i.imgur.com/5cUEifg.gif")
```


Below are a few more sophisticated examples of dynamic input:

* Font Color
  * https://gallery.shinyapps.io/sass-font
  * `shiny::runApp(system.file("sass-font", package = "sass"))`
* Sizing
  * https://gallery.shinyapps.io/sass-size
  * `shiny::runApp(system.file("sass-size", package = "sass"))`
* Themes
  * https://gallery.shinyapps.io/sass-theme
  * `shiny::runApp(system.file("sass-theme", package = "sass"))`


## In rmarkdown {#rmarkdown}

**knitr** [recently gained](https://github.com/yihui/knitr/pull/1666) a Sass engine powered by the **sass** package. This means you can write Sass code directly into a code `sass` chunk and the resulting CSS will be included in the resulting document (The `echo = FALSE` prevents the Sass code from being shown in the resulting document).

    ```{sass, echo = FALSE}`r ''`
    $body-bg: red;
    body{
      background-color: $body-bg;
    }
    ```

If you like to write R **sass** code instead, you can do that as well, and by default it works similarly to the `sass` engine (except that the sass-specific code chunk options will be ignored, but you can specify those [options](#options) via `sass::sass()` instead).

    ```{r, echo = FALSE}`r ''`
    sass(sass_file("my-style.scss"))
    ```

If syntax highlighting is enabled in your output document , it's also possible to display the generated CSS (instead of embedding it as HTML) with syntax highlighting by setting the code chunk options `class.output='css'` and `comment=''`. Unfortunately, for some output formats, like `rmarkdown::html_vignette()`, syntax hightlighting isn't supported, but for output formats like `rmarkdown::html_document()`, you can enable syntax highlighting by setting the `highlight` parameter to a non-default value (e.g., `tango`).

    ```{r, class.output='css', comment=''}`r ''`
    sass(sass_file("my-style.scss"))
    ```

# join_non_null_values combines null elements as expected

    Code
      obj
    Output
      /* Sass Bundle */
      $color: blue;
      .rule-b {}
      .rule-a {}
      .rule-c {}
      /* *** */

# Remote font importing basically works Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output NULL --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output NULL --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" # font_google(local = TRUE) basically works Code tagz$html Output
# Special named args in font_collection Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] "" --- Code tagz$html Output
--- Code tagz$dependencies[[1]]$head Output [1] ""

# sass()/as_sass() relay html dependencies

    Code
      sass(scss)
    Output
      /* CSS */
      body {
        color: green;
      }
      
      
      /* HTML Dependencies */
      List of 1
       $ :List of 10
        ..$ name      : chr "fake1"
        ..$ version   : chr "1.0.0"
        ..$ src       :List of 1
        .. ..$ file: chr ""
        ..$ meta      : NULL
        ..$ script    : NULL
        ..$ stylesheet: NULL
        ..$ head      : NULL
        ..$ attachment: NULL
        ..$ package   : NULL
        ..$ all_files : logi TRUE
        ..- attr(*, "class")= chr "html_dependency"

---

    Code
      as_sass(scss)
    Output
      /* Sass */
      body{color: green}
      
      /* HTML Dependencies */
      List of 1
       $ :List of 10
        ..$ name      : chr "fake1"
        ..$ version   : chr "1.0.0"
        ..$ src       :List of 1
        .. ..$ file: chr ""
        ..$ meta      : NULL
        ..$ script    : NULL
        ..$ stylesheet: NULL
        ..$ head      : NULL
        ..$ attachment: NULL
        ..$ package   : NULL
        ..$ all_files : logi TRUE
        ..- attr(*, "class")= chr "html_dependency"

# sass layer format

    Code
      format(core)
    Output
      [1] "@function my_invert($color, $amount: 100%) {\n    $inverse: change-color($color, $hue: hue($color) + 180);\n    @return mix($inverse, $color, $amount);\n  }\n$color: blue !default;\nbody { background-color: $color; color: my_invert($color); }"

---

    Code
      core
    Output
      /* Sass Bundle */
      @function my_invert($color, $amount: 100%) {
          $inverse: change-color($color, $hue: hue($color) + 180);
          @return mix($inverse, $color, $amount);
        }
      $color: blue !default;
      body { background-color: $color; color: my_invert($color); }
      /* *** */

# sass_layer_file() basically works

    Code
      str(sass_layer_file(f))
    Output
      List of 1
       $ layers:List of 1
        ..$ :List of 7
        .. ..$ functions       : chr [1:7] "@function color-contrast($color) {" "  @return if(" "    red($color) * 0.299 + green($color) * 0.587 + blue($color) * 0.114 > 186," "    black, white" ...
        .. ..$ defaults        : chr [1:2] "$body-color:            color-contrast($body-bg) !default;" ""
        .. ..$ mixins          : chr [1:4] "@mixin body-color {" "  color: $body-color" "}" ""
        .. ..$ rules           : chr [1:3] "body {" "  @include body-color;" "}"
        .. ..$ declarations    : NULL
        .. ..$ html_deps       : NULL
        .. ..$ file_attachments: chr(0) 
        .. ..- attr(*, "class")= chr [1:2] "sass_layer" "list"
       - attr(*, "class")= chr "sass_bundle"
